#ifndef __AudioCore_h__
#define __AudioCore_h__

#include "SDL/SDL.h"
#include <string>

using namespace std;

class AudioCore {
/* --- singleton stuff --- */
public:
	static AudioCore *AC();
	static void Die();

private:
	AudioCore();
	~AudioCore();
	AudioCore(const AudioCore &);
	AudioCore & operator= (const AudioCore &);

	static AudioCore *instance;
	static SDL_mutex *singleton_lock;
/* --- end singleton stuff --- */
public:
	void SetupCore(int freq, int ch);
	static void audio_callback_trampoline(void *ptr, Uint8 *stream, int len) {
		((AudioCore *)ptr)->audio_callback(stream, len);
	}
	void audio_callback(Uint8 *stream, int len);

	SDL_AudioSpec acfmt;

	void LoadSingleWAV(string path);
	void Play();
	void UnloadWAV();
	
	unsigned char *sample;
	int sample_len;
	unsigned char *sample_pos;
};

#endif
