#include "Ground.h"
#include <math.h>

Ground::Ground()
{
	r = 0.5; g = 0.5; b = 0.7;
	x = y = z = 0;
	geoms.resize(1);
}

Ground::~Ground()
{
}

void Ground::Draw()
{
	glColor3f(r, g, b);
	for(int i=-500; i<500; i++) {
		glPushMatrix();
		glTranslatef(i, 0, 0);
		GLfloat line_width=0.5;
		glLineWidth(line_width);
		glBegin(GL_LINES);
		glVertex2f(0, 1000);
		glVertex2f(0, -1000);
		glEnd();
		glPopMatrix();

		glPushMatrix();
		glTranslatef(0, i, 0);
		glBegin(GL_LINES);
		glVertex2f(1000, 0);
		glVertex2f(-1000, 0);
		glEnd();
		glPopMatrix();
	}

	glColor4f(1, 0.8, 0.8, 0.5);
	glBegin(GL_POLYGON);
	for(double n=-M_PI; n<M_PI; n+= 0.05*M_PI) {
		glVertex2d(sin(n)*0.2, cos(n)*0.2);
	}
	glEnd();
}

void Ground::SetupODE(dWorldID, dSpaceID space)
{
	geoms[0] = dCreatePlane(space, 0, 0, 1, 0);
}

