#ifndef __WorldClock_h__
#define __WorldClock_h__

#include "SDL/SDL.h"
#include <string>

using namespace std;

class WorldClock {
/* --- singleton stuff --- */
public:
	static WorldClock *WC();
	static void Die();

private:
	WorldClock();
	~WorldClock();
	WorldClock(const WorldClock &);
	WorldClock & operator= (const WorldClock &);

	static WorldClock *instance;
	static SDL_mutex *singleton_lock;
/* --- end singleton stuff --- */
public:
	void AdvanceTime(double amount);
	double BeginTimedCycle();
	bool DelayTime(double len, double tcl);
	void SetTimeMultiplier(double mult);
	double GetTimeMultiplier();
	void SetPaused(bool p);
	bool IsPaused();
	double now;

private:
	double mult;
	bool paused;
	SDL_mutex *paused_m;
	SDL_cond *paused_c;
};

#endif
