#ifndef __dtime_h__
#define __dtime_h__

#ifdef WIN32

#include <sys/timeb.h>

static inline double dtime(void) {
    struct _timeb tb;
    _ftime(&tb);
    return tb.time + ((double)tb.millitm) / 1000.0;
}

#else

#include <sys/time.h>
static inline double dtime(void) {
	struct timeval tv; struct timezone tz;
	gettimeofday(&tv, &tz);
	return ((double)(tv.tv_sec)) + ((double)(tv.tv_usec)) / 1000000.0;
}

#endif

#endif
